!
! = ColorPlot
!
! author    ::   (KOMATSU Kengo)
! version   :: 1.0
! date      :: 2006/03/20
! copyright :: Copyright (c) K.K & PGK, 2006. All rights reserved.
!
!
! == 
!
! Υ֥롼 PGPLOT ѤƤޤ PGPLOT ˤĤƤ
! PGPLOT Υޥ˥奢ʤɤ򻲾ȤƤ
!
! ꤷ x ͤκǾ͡xminˡ͡xmaxˡy ͤκǾ
! yminˡ͡ymaxˤϰϤ value ͤ򥫥顼ǥץåȤ
! ޤ٤礦ִ֤ x  xwidth  y  ywidth ǻ
! ꤷޤx = (i-1) * xwidth + xmin, y = (i-1) * ywidth + ymin 
!  value(i,j) ƤޤƼǿ vi, vj Ϥ줾
!  (xmax-xmin)/xwidth + 1, (ymax-ymin)/ywidth + 1 ǡ
! ǤʤƤϤʤޤ󡣡źϰϤϤ줾 1vi, 1vj Ǥ
!  vi, vj ϰͿɬפޤ顼κ͡Ǿͤ
! ưŪ value κ͡Ǿͤˤޤ
!
! 顼 linear/logscale λ logscale_v ǹԤޤ 0:linear
! 1:logscale, ˡޤΥȥ롢x Υȥ롢y Υȥ롢顼
! СΥȥϤ줾졢title_t, title_x, title_y, title_c Ϳ
! ޤƥȥ䥫顼Сΰ֤ landscape ˺ŬƤޤ
!
! Υ֥롼ǻѤƤ륵֥롼 setcolor ϥ顼
! ѥåȤǤ 0 Ϳȥ顼 1 Ϳȥ졼ˤʤ
! ޤ
!
!
! == 
!
! ȡ
!
!
subroutine ColorPlot(xmin,xmax,ymin,ymax,xwidth,ywidth,value,vi,vj,   &
     &               title_t,title_x,title_y,title_c,logscale_v)
  !
  ! ꤷ x ͤκǾ͡͡y ͤκǾͤ͡ϰϤ
  !  value ͤ򥫥顼ǥץåȤޤ
  !
  implicit none
  real(4), intent(in) :: xmin           ! x κǾ
  real(4), intent(in) :: xmax           ! x κ
  real(4), intent(in) :: ymin           ! y κǾ
  real(4), intent(in) :: ymax           ! y κ
  real(4), intent(in) :: xwidth         ! x  ( i,i+1 ֤ x  )
  real(4), intent(in) :: ywidth         ! y  ( j,j+1 ֤ y  )
  integer, intent(in) :: vi, vj         !  value ǿ
  real(4), intent(in) :: value(1:vi,1:vj)  ! ɸ (x,y) Ǥ
  character(len=*), intent(in) :: title_t  ! ޤΥȥ
  character(len=*), intent(in) :: title_x  ! x Υȥ
  character(len=*), intent(in) :: title_y  ! y Υȥ
  character(len=*), intent(in) :: title_c  ! 顼СΥȥ
  integer, intent(in) :: logscale_v     ! value ɽ
                                        ! (0:linear, 1:logscale)
  real(4)             :: xmin_t, xmax_t, ymin_t, ymax_t
  real(4)             :: x1, x2, y1, y2
  integer             :: min_sub(1:2), max_sub(1:2)
  real(4)             :: value_min, value_max
  integer             :: i, j
  integer             :: l
  external setcolor

  ! ---- ξüĴ ----
  xmin_t = xmin - xwidth/2.0
  xmax_t = xmax + xwidth/2.0
  ymin_t = ymin - ywidth/2.0
  ymax_t = ymax + ywidth/2.0

  ! ---- ν ----
  call PGBEG(0,'?',1,1)                         ! ޤʤ
  call PGSLW(4)                                 ! 
  call PGSCF(2)                                 ! font 
  call PGSCH(1.3)                               ! ʸ礭
  call PGENV(xmin_t,xmax_t,ymin_t,ymax_t,0,-2)  ! Ȥ
  call PGSVP(0.10,0.89,0.10,0.90)               ! Ȥ礭
  call PGMTXT('T',0.5,0.5,0.5,title_t)          ! ޤΥȥ
  call PGMTXT('B',2.5,0.5,0.5,title_x)          ! x Υȥ
  call PGMTXT('L',3.0,0.5,0.5,title_y)          ! y Υȥ
  call setcolor(0)                              ! 顼ѥå
                                                ! (0=color,1=grey)

  ! ---- value κ͡Ǿ ----
  min_sub(:) = minloc(value(:,:))
  max_sub(:) = maxloc(value(:,:))
  value_min  = value(min_sub(1),min_sub(2))
  value_max  = value(max_sub(1),max_sub(2))

  ! ---- ɤ٤ ----
  do j=1,vj
     do i=1,vi
        l = int( 63*(value(i,j)-value_min)/(value_max-value_min) )+11
        if( l .gt. 74 ) l=74
        if( l .lt. 11 ) l=11
        call PGSCI(l)                     ! 顼ǥå
        x1 = (i-1) * xwidth + xmin_t
        x2 =  i    * xwidth + xmin_t
        y1 = (j-1) * ywidth + ymin_t
        y2 =  j    * ywidth + ymin_t
        call PGRECT(x1,x2,y1,y2)
     enddo
  end do

  ! ---- ξܺ ----
  call PGSCI(1)
  call PGSLW(4)
  call PGSCH(1.2)
  call PGBOX('BCTSN',0.0,0,'BCTSNV',0.0,0)

  ! ---- 顼С ----
  call PGSCH(0.9)                           ! ʸ礭
  call PGSVP(0.90,0.93,0.2,0.8)             ! Ȥ礭
  call PGSWIN(0.0,0.5,value_min,value_max)  ! 
  call PGMTXT('R',4.0,0.5,0.5,title_c)      ! ȥ
  do i=11,74
     y1 = value_min + real(i-11) * (value_max-value_min) / 63.0
     y2 = value_min + real(i-10) * (value_max-value_min) / 63.0
     call PGSCI(i)
     call PGRECT(0.0,0.5,y1,y2)
  enddo
  call PGSCI(1)
  if (logscale_v==1) then
     call PGBOX('BCI',0.0,0,'BCMTSVL2',0.0,0)
  else
     call PGBOX('BCI',0.0,0,'BCMTSV',0.0,0)
  end if

  ! ---- λ ----
  call PGEND
  return
end subroutine ColorPlot


subroutine setcolor(icg)
  !
  ! 顼ѥå
  ! author ::  Ž (WATANABE Shigeto)
  !
  real*4 cr(64), cg(64), cb(64)
  real*4 gr(64), gg(64), gb(64)
  data   cr/ 0.00,0.00,0.00,0.00,0.00,0.10,0.10,0.10,0.20,0.20, &
&             0.20,0.20,0.10,0.10,0.10,0.00,0.00,0.00,0.00,0.00, &
&             0.00,0.00,0.00,0.00,0.10,0.20,0.30,0.40,0.50,0.60, &
&             0.70,0.80,0.90,1.00,1.00,1.00,1.00,1.00,1.00,1.00, &
&             1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00, &
&             1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00, &
&             1.00,1.00,1.00,1.00/
  data   cg/ 0.00,0.00,0.10,0.20,0.30,0.40,0.50,0.55,0.60,0.65, &
&             0.70,0.90,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00, &
&             1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00, &
&             1.00,1.00,1.00,1.00,0.99,0.98,0.97,0.96,0.95,0.94, &
&             0.93,0.92,0.91,0.90,0.88,0.86,0.83,0.80,0.75,0.70, &
&             0.65,0.60,0.55,0.50,0.45,0.40,0.30,0.20,0.10,0.00, &
&             0.00,0.00,0.00,0.00/
  data   cb/ 1.00,0.98,0.97,0.96,0.95,0.94,0.93,0.92,0.91,0.90, &
&             0.88,0.86,0.84,0.82,0.80,0.75,0.70,0.60,0.50,0.40, &
&             0.30,0.20,0.10,0.00,0.00,0.00,0.00,0.00,0.00,0.00, &
&             0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00, &
&             0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00, &
&             0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00, &
&             0.00,0.00,0.00,0.00/
  data   gr/ 0.00,0.01,0.02,0.03,0.04,0.05,0.06,0.07,0.08,0.09, &
&             0.10,0.11,0.12,0.13,0.14,0.15,0.16,0.17,0.18,0.19, &
&             0.20,0.22,0.24,0.26,0.28,0.30,0.32,0.34,0.36,0.38, &
&             0.40,0.42,0.44,0.46,0.48,0.50,0.52,0.54,0.56,0.58, &
&             0.60,0.62,0.64,0.66,0.68,0.70,0.72,0.74,0.76,0.78, &
&             0.80,0.82,0.84,0.86,0.88,0.90,0.92,0.94,0.95,0.96, &
&             0.97,0.98,0.99,1.00/
  data   gg/ 0.00,0.01,0.02,0.03,0.04,0.05,0.06,0.07,0.08,0.09, &
&             0.10,0.11,0.12,0.13,0.14,0.15,0.16,0.17,0.18,0.19, &
&             0.20,0.22,0.24,0.26,0.28,0.30,0.32,0.34,0.36,0.38, &
&             0.40,0.42,0.44,0.46,0.48,0.50,0.52,0.54,0.56,0.58, &
&             0.60,0.62,0.64,0.66,0.68,0.70,0.72,0.74,0.76,0.78, &
&             0.80,0.82,0.84,0.86,0.88,0.90,0.92,0.94,0.95,0.96, &
&             0.97,0.98,0.99,1.00/
  data   gb/ 0.00,0.01,0.02,0.03,0.04,0.05,0.06,0.07,0.08,0.09, &
&             0.10,0.11,0.12,0.13,0.14,0.15,0.16,0.17,0.18,0.19, &
&             0.20,0.22,0.24,0.26,0.28,0.30,0.32,0.34,0.36,0.38, &
&             0.40,0.42,0.44,0.46,0.48,0.50,0.52,0.54,0.56,0.58, &
&             0.60,0.62,0.64,0.66,0.68,0.70,0.72,0.74,0.76,0.78, &
&             0.80,0.82,0.84,0.86,0.88,0.90,0.92,0.94,0.95,0.96, &
&             0.97,0.98,0.99,1.00/
  if( icg .eq. 0 ) then
     do i=11,74
        call pgscr(i,cr(i-10),cg(i-10),cb(i-10))
     end do
  endif
  if( icg .eq. 1 ) then
     do i=11,74
        call pgscr(i,gr(75-i),gg(75-i),gb(75-i))
     end do
  endif
  return
end subroutine setcolor
